/*****************************************************************************\
*
* clipPlane.cpp
*
* LINAC - simulation of using LINAC for acceleration of electron
*
* Authors: Ondrej Peterka (xpeter08 _AT stud.fit.vutbr.cz)
*          PCJohn (peciva _AT fit.vutbr.cz)
* Contributors:
*
* ----------------------------------------------------------------------------
*
* THIS SOFTWARE IS NOT COPYRIGHTED
*
* This source code is offered for use in the public domain.
* You may use, modify or distribute it freely.
*
* This source code is distributed in the hope that it will be useful but
* WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
* DISCLAIMED.  This includes but is not limited to warranties of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* If you find the source code useful, authors will kindly welcome
* if you give them credit and keep their names with their source code,
* but do not feel to be forced to do so.
*
\*****************************************************************************/
#include "clipPlane.h"

#include <iostream>

#include <Inventor/engines/SoCalculator.h> 
#include <Inventor/fields/SoSFPlane.h> 
#include <Inventor/SbLinear.h> 
#include <Inventor/nodes/SoCamera.h> 
#include <Inventor/sensors/SoFieldSensor.h> 

SoClipPlane * clip; //clip plane
SoWinExaminerViewer * viewer; //globalni promena - viewer cele sceny

extern bool bClipPlane; //ma byt orezano?
extern bool bITClipPlane; //ma byt pouzita vylepsena fce orezani?


///////////callback funkce pro zmenu clip plane (reakce na field sensory)
///////////////////////////////////////////////////////////////////////////
void sensorClipClb(void * clip, SoSensor * sensor) {

  SoSFPlane  pl ; //plane na orez
  SbVec3f nullPoint(0,0,0); //pocatek

	if (bITClipPlane && bClipPlane) {

		((SoClipPlane*) clip)->on.setValue(true);
	     SoCamera * cam = viewer->getCamera();
	   

	     SbRotation camrot = cam->orientation.getValue();
	
		 SbVec3f lookat(0, 0, -1); // init to default view direction vector
         camrot.multVec(lookat, lookat);

	     if (lookat.length == 0) return;
	
	     SbVec3f linVec(0,0,1);
	     lookat=lookat.cross(linVec); //lookat bude normalou jedne roviny


	     if (lookat[0] == 0 && lookat[1] == 0 && lookat[2] == 0 ) return;
	     linVec=linVec.cross(lookat); //linVec bude vysledna normala


;
    	 if (linVec[0] == 0 && linVec[1] == 0 && linVec[2] == 0)  return;
	     pl.setValue(SbPlane(linVec,nullPoint));

	} else {//if
		if (bClipPlane) {//chci orezavat ale ne IT
			pl.setValue(SbPlane(SbVec3f(1,0,0),nullPoint));
			((SoClipPlane*) clip)->on.setValue(true);

		} else { //nechci zadnou  orezavaci rovinu
			pl.setValue(SbPlane(SbVec3f(1,0,0),nullPoint));

			((SoClipPlane*) clip)->on.setValue(false);
		}
	}


	//nastaveni na vytvorenou rovinu
	((SoClipPlane*) clip)->plane = pl;	



	

} //end sensorClipClb


////vytvori clip plane a senzory pro IT clip plane
////////////////////////////////////////////////////
SoClipPlane * makeClipPlane(SoWinExaminerViewer * viewerX){
	clip = new SoClipPlane();

	viewer = viewerX;


	SoFieldSensor * sensor1 = new SoFieldSensor(sensorClipClb,clip);
	sensor1->attach(&(viewer->getCamera()->position));

	SoFieldSensor * sensor2 = new SoFieldSensor(sensorClipClb,clip);
	sensor2->attach(&(viewer->getCamera()->orientation));


	return clip;



}