/*****************************************************************************\
*
* elektron.h
*
* LINAC - simulation of using LINAC for acceleration of electron
*
* Authors: Ondrej Peterka (xpeter08 _AT stud.fit.vutbr.cz)
*          PCJohn (peciva _AT fit.vutbr.cz)
* Contributors:
*
* ----------------------------------------------------------------------------
*
* THIS SOFTWARE IS NOT COPYRIGHTED
*
* This source code is offered for use in the public domain.
* You may use, modify or distribute it freely.
*
* This source code is distributed in the hope that it will be useful but
* WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
* DISCLAIMED.  This includes but is not limited to warranties of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* If you find the source code useful, authors will kindly welcome
* if you give them credit and keep their names with their source code,
* but do not feel to be forced to do so.
*
\*****************************************************************************/

#include <Inventor/SbColor.h>
#include <Inventor/SbTime.h>
#include <Inventor/SbLinear.h> 
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoSphere.h>
#include <list>
class SoTranslation;
class SoSeparator;

 

class Elektron {
	protected:
		float p_x, p_y, p_z;
		SoTranslation *translation;
		
	public:

		Elektron(float pos_x, float pos_y, float pos_z,float size, SbColor color,
			    const char *textureName, 
			    float lVec, float vel_x, float vel_y, float vel_z,
		     	SoSeparator *sceneRoot = NULL);


		void setPosition(float *array);
		void getPosition(float *array);
		
		static void updatePositions(std::list<Elektron*> * elektrons,float sizeOfLINAC,
			const SbTime dt, const SbTime lastTimeTick,SoSeparator * root);

		

		SoMaterial * material;
		SoSphere * sphere;


		
		int lastBoost;
		double Energie;
		bool velsimON;
		SoSeparator * Croot;
		float maxlv, v_x, v_y, v_z;

		
		

};

class Micro: public Elektron {
public:
			Micro(float pos_x, float pos_y, float pos_z,float size, SbColor color,
			    const char *textureName, 
			    float lVec, float vel_x, float vel_y, float vel_z,
		     	SoSeparator *sceneRoot = NULL);

		    static void updatePositionsMicro(std::list<Micro*> * micros,
			       const SbTime dt, const SbTime lastTimeTick,SoSeparator * root);

			bool getVecOver();

			float bPos_x,bPos_y,bPos_z;
};

void deleteElektrons(SoSeparator * r, std::list<Elektron*> * elektrons);
void deleteAllElektrons(std::list<Elektron*> *elektrons,SoSeparator * root);
void deleteMicros(SoSeparator * r, std::list<Micro*> * micros);
void deleteAllMicros(std::list<Micro*> *micros,SoSeparator * root);
